Skip to main content

This browser is no longer supported.

Upgrade to Microsoft Edge to take advantage of the latest features, security updates, and technical support.

Download Microsoft Edge More info about Internet Explorer and Microsoft Edge
microsoft-foundry.rest.security.o-auth2-auth

Training

Forward and backward pass

POST /fine_tuning/sessions/{sessionId}/forward_backward

Submit a mini-batch for a combined forward and backward pass. Gradients accumulate until an optimizer step is issued. Poll the returned request identifier for the result.

Header parameters

Foundry-Features enum required

A feature flag opt-in required when using preview operations or modifying persisted preview resources.

FineTuningSessions=V1Preview

Path parameters

sessionId string required

Identifier of the fine-tuning session that will process the batch.

Query parameters

api-version string required

The API version to use for this operation.

Request Body

Training batch and loss configuration for the forward-backward pass.

Content-Type: application/json
forward_backward_input SessionFineTuning.ForwardBackwardInput required

Inner payload for a forward-backward request.

data SessionFineTuning.FineTuningDatum[] required

Training examples to process in this batch.

loss_fn string | enum required

Supported loss functions for forward-backward passes.

Any of the following:
string
enum
cross_entropyimportance_samplingppocisposapo
loss_fn_config SessionFineTuning.LossFnConfig

Optional per-loss-function hyper-parameters.

clip_low_threshold number

PPO (Proximal Policy Optimization) / CISPO (Clipped Importance-Sampled Policy Optimization): lower clip threshold.

clip_high_threshold number

PPO (Proximal Policy Optimization) / CISPO (Clipped Importance-Sampled Policy Optimization): upper clip threshold.

tau_pos number

SAPO (Soft Adaptive Policy Optimization): positive advantage temperature.

tau_neg number

SAPO (Soft Adaptive Policy Optimization): negative advantage temperature.

Responses

The request has succeeded.

Body

Content-Type: application/json
request_id string required

Request identifier to pass to the session's request-status endpoint.

status enum required

Indicates that the request has not yet completed.

pending
session_id string required

Identifier of the session processing this request.

Client error

Headers

x-ms-error-code string

String error code indicating what went wrong.

Body

Content-Type: application/json
error OpenAI.Error required
code string | null required
message string required
param string | null
type string
misalignment OpenAI.MisalignmentErrorDetailsResource
review_target string | null
error_type string | enum
Any of the following:
string
enum
potentially_unintended_data_transferpotentially_unintended_data_accesspotentially_unintended_destructive_activityother
detailed_explanation string

The public explanation for this block.

steer OpenAI._MisalignmentSteer
message string required

The public continuation instruction.

details OpenAI.Error[]

Additional errors that contributed to this failure.

additionalInfo object

Additional structured information about the failure.

debugInfo object

Diagnostic information supplied by the service for troubleshooting.

Server error

Headers

x-ms-error-code string

String error code indicating what went wrong.

Body

Content-Type: application/json
error OpenAI.Error required
code string | null required
message string required
param string | null
type string
misalignment OpenAI.MisalignmentErrorDetailsResource
review_target string | null
error_type string | enum
Any of the following:
string
enum
potentially_unintended_data_transferpotentially_unintended_data_accesspotentially_unintended_destructive_activityother
detailed_explanation string

The public explanation for this block.

steer OpenAI._MisalignmentSteer
message string required

The public continuation instruction.

details OpenAI.Error[]

Additional errors that contributed to this failure.

additionalInfo object

Additional structured information about the failure.

debugInfo object

Diagnostic information supplied by the service for troubleshooting.

Request

POST /fine_tuning/sessions/{sessionId}/forward_backward HTTP/1.1

Response

Status: 200
Content-Type: application/json
Status: 4XX
Content-Type: application/json
Status: 5XX
Content-Type: application/json
en-us
Your Privacy Choices
  • AI Disclaimer
  • Previous Versions
  • Blog
  • Contribute
  • Privacy
  • Consumer Health Privacy
  • Terms of Use
  • Trademarks
  • © Microsoft 2026